//+------------------------------------------------------------------+
//|                                                  tick_export.mq5 |
//|                                                            IgorM |
//|                               http://www.mql4.com/ru/users/IgorM |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "http://www.mql4.com/ru/users/IgorM"
#property version   "1.00"

#define arr_size 30

input string filename   = "tick_"; // 

string tmpsym;
MqlTick  tmpdata;          //  ,       


class tick{
   public:
      MqlTick  data;             //  
      bool     refresh();        //         
      void     write();          //    
      void     tick();
      void     ~tick();
      string   sym;               // 
   private:
      int      file_handle;      //   
      int      tickCounter;
      int      time[arr_size];
      datetime lasttick;         //  ,         
      
};

static int totalsym =0;
tick *arr_oftick[];

//___________________________________________________________________
void tick::tick(void){
   sym = tmpsym;
   lasttick = 0;
   tickCounter = GetTickCount();
   ArrayInitialize(time,500);
   file_handle = FileOpen(filename+sym+".txt",FILE_READ|FILE_WRITE|FILE_TXT|FILE_SHARE_READ);
   if (file_handle<0)Print("   Symbol=",sym,", error ",GetLastError());
      else FileSeek(file_handle,0,SEEK_END);
}

void tick::~tick(void){
   if (file_handle>0) {FileFlush(file_handle); FileClose(file_handle);}
}

bool tick::refresh(void){
   if (!SymbolInfoTick(sym,tmpdata)) return(false);
   if (tmpdata.time!=lasttick)     {data=tmpdata;lasttick=data.time; return(true);}
   if (data.ask!=tmpdata.ask)      {data=tmpdata;lasttick=data.time; return(true);}
   if (data.bid!=tmpdata.bid)      {data=tmpdata;lasttick=data.time; return(true);}
   if (data.volume!=tmpdata.volume){data=tmpdata;lasttick=data.time; return(true);}
return(false);
}

void tick::write(void){
   if (file_handle>0)FileWrite(file_handle,data.bid);
}
//___________________________________________________________________
int OnInit(){
   int i,arrrange;
   totalsym= SymbolsTotal(true);
   if (totalsym>15)totalsym=15;
   for(i=0;i<totalsym;i++){
         arrrange = ArrayRange(arr_oftick,0);
         arrrange++;
         ArrayResize(arr_oftick,arrrange);
         tmpsym = SymbolName(i,true);
         arr_oftick[i] = new tick();
   }
return(0);
}
//___________________________________________________________________
void OnDeinit(const int reason){
   int i;
   for(i=0;i<totalsym;i++) delete arr_oftick[i];
   ArrayResize(arr_oftick,1);
}
//___________________________________________________________________
void OnTick(){
   int i=0;
   while(!IsStopped()){
         if (i>=totalsym) i=0;
         if (arr_oftick[i].refresh())arr_oftick[i].write(); //Print("tick ",arr_oftick[i].sym);}
         i++;
         Sleep(300);
   }
}
//___________________________________________________________________
